/*
 *   libcddb - CDDB Interface Library for xmcd/cda
 *
 *      This library implements an interface to access the "classic"
 *      CDDB1 services.
 *
 *   Copyright (C) 1993-2001  Ti Kan
 *   E-mail: xmcd@amb.org
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#ifndef _REGIONTBL_H_
#define _REGIONTBL_H_

#ifndef LINT
static char     *_regiontbl_h_ident_ = "@(#)regiontbl.h	7.2 01/04/09";
#endif


/*
 * Region table - This table will need updating when world nations change
 */
cddb_region_t	fcddb_region_tbl[] = {
    {	"",	"1",	"United States",			NULL	},
    {	"",	"2",	"Canada",				NULL	},
    {	"",	"3",	"Afghanistan",				NULL	},
    {	"",	"4",	"Albania",				NULL	},
    {	"",	"5",	"Algeria",				NULL	},
    {	"",	"6",	"American Samoa",			NULL	},
    {	"",	"7",	"Andorra",				NULL	},
    {	"",	"8",	"Angola",				NULL	},
    {	"",	"9",	"Anguilla",				NULL	},
    {	"",	"10",	"Antarctica",				NULL	},
    {	"",	"11",	"Antigua and Barbuda",			NULL	},
    {	"",	"12",	"Argentina",				NULL	},
    {	"",	"13",	"Armenia",				NULL	},
    {	"",	"14",	"Aruba",				NULL	},
    {	"",	"15",	"Ashmore and Cartier Islands",		NULL	},
    {	"",	"16",	"Australia",				NULL	},
    {	"",	"17",	"Austria",				NULL	},
    {	"",	"18",	"Azerbaijan",				NULL	},
    {	"",	"19",	"Bahamas",				NULL	},
    {	"",	"20",	"Bahrain",				NULL	},
    {	"",	"21",	"Baker Island",				NULL	},
    {	"",	"22",	"Bangladesh",				NULL	},
    {	"",	"23",	"Barbados",				NULL	},
    {	"",	"24",	"Bassas da India",			NULL	},
    {	"",	"25",	"Belarus",				NULL	},
    {	"",	"26",	"Belgium",				NULL	},
    {	"",	"27",	"Belize",				NULL	},
    {	"",	"28",	"Benin",				NULL	},
    {	"",	"29",	"Bermuda",				NULL	},
    {	"",	"30",	"Bhutan",				NULL	},
    {	"",	"31",	"Bolivia",				NULL	},
    {	"",	"32",	"Bosnia and Herzegovina",		NULL	},
    {	"",	"33",	"Botswana",				NULL	},
    {	"",	"34",	"Bouvet Island",			NULL	},
    {	"",	"35",	"Brazil",				NULL	},
    {	"",	"36",	"British Indian Ocean Territory",	NULL	},
    {	"",	"37",	"British Virgin Islands",		NULL	},
    {	"",	"38",	"Brunei",				NULL	},
    {	"",	"39",	"Bulgaria",				NULL	},
    {	"",	"40",	"Burkina Faso",				NULL	},
    {	"",	"41",	"Burma",				NULL	},
    {	"",	"42",	"Burundi",				NULL	},
    {	"",	"43",	"Cambodia",				NULL	},
    {	"",	"44",	"Cameroon",				NULL	},
    {	"",	"45",	"Cape Verde",				NULL	},
    {	"",	"46",	"Cayman Islands",			NULL	},
    {	"",	"47",	"Central African Republic",		NULL	},
    {	"",	"48",	"Chad",					NULL	},
    {	"",	"49",	"Chile",				NULL	},
    {	"",	"50",	"China",				NULL	},
    {	"",	"51",	"Christmas Island",			NULL	},
    {	"",	"52",	"Clipperton Island",			NULL	},
    {	"",	"53",	"Cocos Islands",			NULL	},
    {	"",	"54",	"Colombia",				NULL	},
    {	"",	"55",	"Comoros",				NULL	},
    {	"",	"56",	"Congo",				NULL	},
    {	"",	"57",	"Cook Islands",				NULL	},
    {	"",	"58",	"Coral Sea Islands",			NULL	},
    {	"",	"59",	"Costa Rica",				NULL	},
    {	"",	"60",	"Cote d'Ivoire",			NULL	},
    {	"",	"61",	"Croatia",				NULL	},
    {	"",	"62",	"Cuba",					NULL	},
    {	"",	"63",	"Cyprus",				NULL	},
    {	"",	"64",	"Czech Republic",			NULL	},
    {	"",	"65",	"Denmark",				NULL	},
    {	"",	"66",	"Djibouti",				NULL	},
    {	"",	"67",	"Dominica",				NULL	},
    {	"",	"68",	"Dominican Republic",			NULL	},
    {	"",	"69",	"Ecuador",				NULL	},
    {	"",	"70",	"Egypt",				NULL	},
    {	"",	"71",	"El Salvador",				NULL	},
    {	"",	"72",	"Equatorial Guinea",			NULL	},
    {	"",	"73",	"Eritrea",				NULL	},
    {	"",	"74",	"Estonia",				NULL	},
    {	"",	"75",	"Ethiopia",				NULL	},
    {	"",	"76",	"Europa Island",			NULL	},
    {	"",	"77",	"Falkland Islands",			NULL	},
    {	"",	"78",	"Faroe Islands",			NULL	},
    {	"",	"79",	"Fiji",					NULL	},
    {	"",	"80",	"Finland",				NULL	},
    {	"",	"81",	"France",				NULL	},
    {	"",	"82",	"French Guiana",			NULL	},
    {	"",	"83",	"French Polynesia",			NULL	},
    {	"",	"84",	"French Southern and Antarctic Lands",	NULL	},
    {	"",	"85",	"Gabon",				NULL	},
    {	"",	"86",	"Gambia",				NULL	},
    {	"",	"87",	"Gaza Strip",				NULL	},
    {	"",	"88",	"Georgia",				NULL	},
    {	"",	"89",	"Germany",				NULL	},
    {	"",	"90",	"Ghana",				NULL	},
    {	"",	"91",	"Gibraltar",				NULL	},
    {	"",	"92",	"Glorioso Islands",			NULL	},
    {	"",	"93",	"Greece",				NULL	},
    {	"",	"94",	"Greenland",				NULL	},
    {	"",	"95",	"Grenada",				NULL	},
    {	"",	"96",	"Guadeloupe",				NULL	},
    {	"",	"97",	"Guam",					NULL	},
    {	"",	"98",	"Guatemala",				NULL	},
    {	"",	"99",	"Guernsey",				NULL	},
    {	"",	"100",	"Guinea",				NULL	},
    {	"",	"101",	"Guinea-Bissau",			NULL	},
    {	"",	"102",	"Guyana",				NULL	},
    {	"",	"103",	"Haiti",				NULL	},
    {	"",	"104",	"Heard Island and McDonald Islands",	NULL	},
    {	"",	"105",	"Holy See (Vatican City)",		NULL	},
    {	"",	"106",	"Honduras",				NULL	},
    {	"",	"107",	"Hong Kong",				NULL	},
    {	"",	"108",	"Howland Island",			NULL	},
    {	"",	"109",	"Hungary",				NULL	},
    {	"",	"110",	"Iceland",				NULL	},
    {	"",	"111",	"India",				NULL	},
    {	"",	"112",	"Indonesia",				NULL	},
    {	"",	"113",	"Iran",					NULL	},
    {	"",	"114",	"Iraq",					NULL	},
    {	"",	"115",	"Ireland",				NULL	},
    {	"",	"116",	"Isle of Man",				NULL	},
    {	"",	"117",	"Israel",				NULL	},
    {	"",	"118",	"Italy",				NULL	},
    {	"",	"119",	"Jamaica",				NULL	},
    {	"",	"120",	"Jan Mayen",				NULL	},
    {	"",	"121",	"Japan",				NULL	},
    {	"",	"122",	"Jarvis Island",			NULL	},
    {	"",	"123",	"Jersey",				NULL	},
    {	"",	"124",	"Johnston Atoll",			NULL	},
    {	"",	"125",	"Jordan",				NULL	},
    {	"",	"126",	"Juan de Nova Island",			NULL	},
    {	"",	"127",	"Kazakhstan",				NULL	},
    {	"",	"128",	"Kenya",				NULL	},
    {	"",	"129",	"Kingman Reef",				NULL	},
    {	"",	"130",	"Kiribati",				NULL	},
    {	"",	"131",	"North Korea",				NULL	},
    {	"",	"132",	"South Korea",				NULL	},
    {	"",	"133",	"Kuwait",				NULL	},
    {	"",	"134",	"Kyrgyzstan",				NULL	},
    {	"",	"135",	"Laos",					NULL	},
    {	"",	"136",	"Latvia",				NULL	},
    {	"",	"137",	"Lebanon",				NULL	},
    {	"",	"138",	"Lesotho",				NULL	},
    {	"",	"139",	"Liberia",				NULL	},
    {	"",	"140",	"Libya",				NULL	},
    {	"",	"141",	"Liechtenstein",			NULL	},
    {	"",	"142",	"Lithuania",				NULL	},
    {	"",	"143",	"Luxembourg",				NULL	},
    {	"",	"144",	"Macau",				NULL	},
    {	"",	"145",	"Macedonia",				NULL	},
    {	"",	"146",	"Madagascar",				NULL	},
    {	"",	"147",	"Malawi",				NULL	},
    {	"",	"148",	"Malaysia",				NULL	},
    {	"",	"149",	"Maldives",				NULL	},
    {	"",	"150",	"Mali",					NULL	},
    {	"",	"151",	"Malta",				NULL	},
    {	"",	"152",	"Marshall Islands",			NULL	},
    {	"",	"153",	"Martinique",				NULL	},
    {	"",	"154",	"Mauritania",				NULL	},
    {	"",	"155",	"Mauritius",				NULL	},
    {	"",	"156",	"Mayotte",				NULL	},
    {	"",	"157",	"Mexico",				NULL	},
    {	"",	"158",	"Micronesia",				NULL	},
    {	"",	"159",	"Midway Islands",			NULL	},
    {	"",	"160",	"Moldova",				NULL	},
    {	"",	"161",	"Monaco",				NULL	},
    {	"",	"162",	"Mongolia",				NULL	},
    {	"",	"163",	"Montserrat",				NULL	},
    {	"",	"164",	"Morocco",				NULL	},
    {	"",	"165",	"Mozambique",				NULL	},
    {	"",	"166",	"Namibia",				NULL	},
    {	"",	"167",	"Nauru",				NULL	},
    {	"",	"168",	"Navassa Island",			NULL	},
    {	"",	"169",	"Nepal",				NULL	},
    {	"",	"170",	"Netherlands",				NULL	},
    {	"",	"171",	"Netherlands Antilles",			NULL	},
    {	"",	"172",	"New Caledonia",			NULL	},
    {	"",	"173",	"New Zealand",				NULL	},
    {	"",	"174",	"Nicaragua",				NULL	},
    {	"",	"175",	"Niger",				NULL	},
    {	"",	"176",	"Nigeria",				NULL	},
    {	"",	"177",	"Niue",					NULL	},
    {	"",	"178",	"Norfolk Island",			NULL	},
    {	"",	"179",	"Northern Mariana Islands",		NULL	},
    {	"",	"180",	"Norway",				NULL	},
    {	"",	"181",	"Oman",					NULL	},
    {	"",	"182",	"Pakistan",				NULL	},
    {	"",	"183",	"Palau",				NULL	},
    {	"",	"184",	"Palmyra Atoll",			NULL	},
    {	"",	"185",	"Panama",				NULL	},
    {	"",	"186",	"Papua New Guinea",			NULL	},
    {	"",	"187",	"Paracel Islands",			NULL	},
    {	"",	"188",	"Paraguay",				NULL	},
    {	"",	"189",	"Peru",					NULL	},
    {	"",	"190",	"Philippines",				NULL	},
    {	"",	"191",	"Pitcairn Islands",			NULL	},
    {	"",	"192",	"Poland",				NULL	},
    {	"",	"193",	"Portugal",				NULL	},
    {	"",	"194",	"Puerto Rico",				NULL	},
    {	"",	"195",	"Qatar",				NULL	},
    {	"",	"196",	"Reunion",				NULL	},
    {	"",	"197",	"Romania",				NULL	},
    {	"",	"198",	"Russia",				NULL	},
    {	"",	"199",	"Rwanda",				NULL	},
    {	"",	"200",	"Saint Helena",				NULL	},
    {	"",	"201",	"Saint Kitts and Nevis",		NULL	},
    {	"",	"202",	"Saint Lucia",				NULL	},
    {	"",	"203",	"Saint Pierre and Miquelon",		NULL	},
    {	"",	"204",	"Saint Vincent and the Grenadines",	NULL	},
    {	"",	"205",	"Samoa",				NULL	},
    {	"",	"206",	"San Marino",				NULL	},
    {	"",	"207",	"Sao Tome and Principe",		NULL	},
    {	"",	"208",	"Saudi Arabia",				NULL	},
    {	"",	"209",	"Senegal",				NULL	},
    {	"",	"210",	"Serbia and Montenegro",		NULL	},
    {	"",	"211",	"Seychelles",				NULL	},
    {	"",	"212",	"Sierra Leone",				NULL	},
    {	"",	"213",	"Singapore",				NULL	},
    {	"",	"214",	"Slovakia",				NULL	},
    {	"",	"215",	"Slovenia",				NULL	},
    {	"",	"216",	"Solomon Islands",			NULL	},
    {	"",	"217",	"Somalia",				NULL	},
    {	"",	"218",	"South Africa",				NULL	},
    {	"",	"219",	"South Georgia and the South Sandwich Islands",	NULL },
    {	"",	"220",	"Spain",				NULL	},
    {	"",	"221",	"Spratly Islands",			NULL	},
    {	"",	"222",	"Sri Lanka",				NULL	},
    {	"",	"223",	"Sudan",				NULL	},
    {	"",	"224",	"Suriname",				NULL	},
    {	"",	"225",	"Svalbard",				NULL	},
    {	"",	"226",	"Swaziland",				NULL	},
    {	"",	"227",	"Sweden",				NULL	},
    {	"",	"228",	"Switzerland",				NULL	},
    {	"",	"229",	"Syria",				NULL	},
    {	"",	"230",	"Taiwan",				NULL	},
    {	"",	"231",	"Tajikistan",				NULL	},
    {	"",	"232",	"Tanzania",				NULL	},
    {	"",	"233",	"Thailand",				NULL	},
    {	"",	"234",	"Togo",					NULL	},
    {	"",	"235",	"Tokelau",				NULL	},
    {	"",	"236",	"Tonga",				NULL	},
    {	"",	"237",	"Trinidad and Tobago",			NULL	},
    {	"",	"238",	"Tromelin Island",			NULL	},
    {	"",	"239",	"Tunisia",				NULL	},
    {	"",	"240",	"Turkey",				NULL	},
    {	"",	"241",	"Turkmenistan",				NULL	},
    {	"",	"242",	"Turks and Caicos Islands",		NULL	},
    {	"",	"243",	"Tuvalu",				NULL	},
    {	"",	"244",	"Uganda",				NULL	},
    {	"",	"245",	"Ukraine",				NULL	},
    {	"",	"246",	"United Arab Emirates",			NULL	},
    {	"",	"247",	"United Kingdom",			NULL	},
    {	"",	"248",	"Uruguay",				NULL	},
    {	"",	"249",	"Uzbekistan",				NULL	},
    {	"",	"250",	"Vanuatu",				NULL	},
    {	"",	"251",	"Venezuela",				NULL	},
    {	"",	"252",	"Vietnam",				NULL	},
    {	"",	"253",	"Virgin Islands",			NULL	},
    {	"",	"254",	"Wake Island",				NULL	},
    {	"",	"255",	"Wallis and Futuna",			NULL	},
    {	"",	"256",	"West Bank",				NULL	},
    {	"",	"257",	"Western Sahara",			NULL	},
    {	"",	"258",	"Yemen",				NULL	},
    {	"",	"259",	"Zambia",				NULL	},
    {	"",	"260",	"Zimbabwe",				NULL	},
    {	"",	NULL,	NULL,					NULL	}
};


#endif	/* _REGIONTBL_H_ */

