/*
 *   xmcd - Motif CD Player
 *
 *   Copyright (C) 1993-2001  Ti Kan
 *   E-mail: xmcd@amb.org
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#ifndef __GEOM_H__
#define __GEOM_H__

#ifndef LINT
static char *_geom_h_ident_ = "@(#)geom.h	7.44 01/07/18";
#endif

/* Location of widgets relative to form origin, express in percentage of
 * form size.
 */

/* Main window widgets: normal mode */
#define LEFT_MODE		0
#define RIGHT_MODE		14
#define TOP_MODE		0
#define BOTTOM_MODE		16

#define LEFT_CHECKBOX		0
#define RIGHT_CHECKBOX		14
#define TOP_CHECKBOX		16
#define BOTTOM_CHECKBOX		68

#define LEFT_EJECT		0
#define RIGHT_EJECT		14
#define TOP_EJECT		68
#define BOTTOM_EJECT		84

#define LEFT_QUIT		0
#define RIGHT_QUIT		14
#define TOP_QUIT		84
#define BOTTOM_QUIT		100

#define LEFT_DISCIND		17
#define RIGHT_DISCIND		25
#define TOP_DISCIND		4
#define BOTTOM_DISCIND		28

#define LEFT_TRACKIND		25
#define RIGHT_TRACKIND		40
#define TOP_TRACKIND		4
#define BOTTOM_TRACKIND		28

#define LEFT_INDEXIND		40
#define RIGHT_INDEXIND		45
#define TOP_INDEXIND		4
#define BOTTOM_INDEXIND		28

#define LEFT_TIMEIND		45
#define RIGHT_TIMEIND		71
#define TOP_TIMEIND		4
#define BOTTOM_TIMEIND		28

#define LEFT_RPTCNTIND		17
#define RIGHT_RPTCNTIND		24
#define TOP_RPTCNTIND		28
#define BOTTOM_RPTCNTIND	42

#define LEFT_DBMODEIND		24
#define RIGHT_DBMODEIND		36
#define TOP_DBMODEIND		28
#define BOTTOM_DBMODEIND	42

#define LEFT_PROGMODEIND	36
#define RIGHT_PROGMODEIND	48
#define TOP_PROGMODEIND		28
#define BOTTOM_PROGMODEIND	42

#define LEFT_TIMEMODEIND	48
#define RIGHT_TIMEMODEIND	59
#define TOP_TIMEMODEIND		28
#define BOTTOM_TIMEMODEIND	42

#define LEFT_PLAYMODEIND	59
#define RIGHT_PLAYMODEIND	71
#define TOP_PLAYMODEIND		28
#define BOTTOM_PLAYMODEIND	42

#define LEFT_DTITLEIND		17
#define RIGHT_DTITLEIND		71
#define TOP_DTITLEIND		44
#define BOTTOM_DTITLEIND	53

#define LEFT_TTITLEIND		17
#define RIGHT_TTITLEIND		71
#define TOP_TTITLEIND		53
#define BOTTOM_TTITLEIND	63

#define LEFT_DBPROG		14
#define RIGHT_DBPROG		24
#define TOP_DBPROG		65
#define BOTTOM_DBPROG		100

#define LEFT_OPTIONS		24
#define RIGHT_OPTIONS		34
#define TOP_OPTIONS		65
#define BOTTOM_OPTIONS		80

#define LEFT_AB			34
#define RIGHT_AB		44
#define TOP_AB			65
#define BOTTOM_AB		80

#define LEFT_SAMPLE		44
#define RIGHT_SAMPLE		54
#define TOP_SAMPLE		65
#define BOTTOM_SAMPLE		80

#define LEFT_TIME		54
#define RIGHT_TIME		64
#define TOP_TIME		65
#define BOTTOM_TIME		80

#define LEFT_KEYPAD		64
#define RIGHT_KEYPAD		74
#define TOP_KEYPAD		65
#define BOTTOM_KEYPAD		80

#define LEFT_WWWWARP		24
#define RIGHT_WWWWARP		34
#define TOP_WWWWARP		80
#define BOTTOM_WWWWARP		100

#define LEFT_LEVEL		34
#define RIGHT_LEVEL		74
#define TOP_LEVEL		80

#define LEFT_PLAYPAUSE		74
#define RIGHT_PLAYPAUSE		100
#define TOP_PLAYPAUSE		0
#define BOTTOM_PLAYPAUSE	18

#define LEFT_STOP		74
#define RIGHT_STOP		100
#define TOP_STOP		18
#define BOTTOM_STOP		36

#define LEFT_PREVDISC		74
#define RIGHT_PREVDISC		87
#define TOP_PREVDISC		36
#define BOTTOM_PREVDISC		52

#define LEFT_NEXTDISC		87
#define RIGHT_NEXTDISC		100
#define TOP_NEXTDISC		36
#define BOTTOM_NEXTDISC		52

#define LEFT_PREVTRK		74
#define RIGHT_PREVTRK		87
#define TOP_PREVTRK		52
#define BOTTOM_PREVTRK		68

#define LEFT_NEXTTRK		87
#define RIGHT_NEXTTRK		100
#define TOP_NEXTTRK		52
#define BOTTOM_NEXTTRK		68

#define LEFT_PREVIDX		74
#define RIGHT_PREVIDX		87
#define TOP_PREVIDX		68
#define BOTTOM_PREVIDX		84

#define LEFT_NEXTIDX		87
#define RIGHT_NEXTIDX		100
#define TOP_NEXTIDX		68
#define BOTTOM_NEXTIDX		84

#define LEFT_REW		74
#define RIGHT_REW		87
#define TOP_REW			84
#define BOTTOM_REW		100

#define LEFT_FF			87
#define RIGHT_FF		100
#define TOP_FF			84
#define BOTTOM_FF		100

/* Main window widgets: basic mode */
#define LEFT_BMODE		0
#define RIGHT_BMODE		17
#define TOP_BMODE		0
#define BOTTOM_BMODE		34

#define LEFT_BEJECT		0
#define RIGHT_BEJECT		17
#define TOP_BEJECT		34
#define BOTTOM_BEJECT		66

#define LEFT_BQUIT		0
#define RIGHT_BQUIT		17
#define TOP_BQUIT		66
#define BOTTOM_BQUIT		100

#define LEFT_BTRACKIND		20
#define RIGHT_BTRACKIND		34
#define TOP_BTRACKIND		8
#define BOTTOM_BTRACKIND	45

#define LEFT_BTIMEIND		34
#define RIGHT_BTIMEIND		68
#define TOP_BTIMEIND		8
#define BOTTOM_BTIMEIND		45

#define LEFT_BLEVEL		17
#define RIGHT_BLEVEL		72
#define TOP_BLEVEL		56

#define LEFT_BPLAYPAUSE		72
#define RIGHT_BPLAYPAUSE	100
#define TOP_BPLAYPAUSE		0
#define BOTTOM_BPLAYPAUSE	34

#define LEFT_BSTOP		72
#define RIGHT_BSTOP		100
#define TOP_BSTOP		34
#define BOTTOM_BSTOP		66

#define LEFT_BPREVTRK		72
#define RIGHT_BPREVTRK		86
#define TOP_BPREVTRK		66
#define BOTTOM_BPREVTRK		100

#define LEFT_BNEXTTRK		86
#define RIGHT_BNEXTTRK		100
#define TOP_BNEXTTRK		66
#define BOTTOM_BNEXTTRK		100

/* Keypad window widgets */
#define LEFT_KEYPADLBL		5
#define RIGHT_KEYPADLBL		95
#define TOP_KEYPADLBL		2
#define BOTTOM_KEYPADLBL	7

#define LEFT_KEYPADIND		17
#define RIGHT_KEYPADIND		83
#define TOP_KEYPADIND		8
#define BOTTOM_KEYPADIND	16

#define LEFT_KPMODEBOX		30
#define RIGHT_KPMODEBOX		70
#define TOP_KPMODEBOX		19
#define BOTTOM_KPMODEBOX	36

#define LEFT_KEY1		5
#define RIGHT_KEY1		35
#define TOP_KEY1		38
#define BOTTOM_KEY1		46

#define LEFT_KEY2		35
#define RIGHT_KEY2		65
#define TOP_KEY2		38
#define BOTTOM_KEY2		46

#define LEFT_KEY3		65
#define RIGHT_KEY3		95
#define TOP_KEY3		38
#define BOTTOM_KEY3		46

#define LEFT_KEY4		5
#define RIGHT_KEY4		35
#define TOP_KEY4		46
#define BOTTOM_KEY4		54

#define LEFT_KEY5		35
#define RIGHT_KEY5		65
#define TOP_KEY5		46
#define BOTTOM_KEY5		54

#define LEFT_KEY6		65
#define RIGHT_KEY6		95
#define TOP_KEY6		46
#define BOTTOM_KEY6		54

#define LEFT_KEY7		5
#define RIGHT_KEY7		35
#define TOP_KEY7		54
#define BOTTOM_KEY7		62

#define LEFT_KEY8		35
#define RIGHT_KEY8		65
#define TOP_KEY8		54
#define BOTTOM_KEY8		62

#define LEFT_KEY9		65
#define RIGHT_KEY9		95
#define TOP_KEY9		54
#define BOTTOM_KEY9		62

#define LEFT_KEY0		35
#define RIGHT_KEY0		65
#define TOP_KEY0		62
#define BOTTOM_KEY0		70

#define LEFT_CLEAR		5
#define RIGHT_CLEAR		35
#define TOP_CLEAR		62
#define BOTTOM_CLEAR		70

#define LEFT_ENTER		65
#define RIGHT_ENTER		95
#define TOP_ENTER		62
#define BOTTOM_ENTER		70

#define LEFT_WARPLBL		5
#define RIGHT_WARPLBL		95
#define TOP_WARPLBL		71
#define BOTTOM_WARPLBL		76

#define LEFT_WARPSCALE		5
#define RIGHT_WARPSCALE		95
#define TOP_WARPSCALE		76
#define BOTTOM_WARPSCALE	83

#define LEFT_KEYPADSEP		0
#define RIGHT_KEYPADSEP		100
#define TOP_KEYPADSEP		85

#define LEFT_KPCANCEL		30
#define RIGHT_KPCANCEL		70
#define TOP_KPCANCEL		88

/* Options window widgets */
#define LEFT_LOAD_LBL		6
#define RIGHT_LOAD_LBL		47
#define TOP_LOAD_LBL		1
#define BOTTOM_LOAD_LBL		5

#define LEFT_LOAD_CHKFRM	6
#define RIGHT_LOAD_CHKFRM	47
#define TOP_LOAD_CHKFRM		5

#define LEFT_LOAD_RADFRM	6
#define RIGHT_LOAD_RADFRM	47
#define TOP_LOAD_RADFRM		11
#define BOTTOM_LOAD_RADFRM	26

#define LEFT_EXIT_LBL		6
#define RIGHT_EXIT_LBL		47
#define TOP_EXIT_LBL		26
#define BOTTOM_EXIT_LBL		30

#define LEFT_EXIT_RADFRM	6
#define RIGHT_EXIT_RADFRM	47
#define TOP_EXIT_RADFRM		30
#define BOTTOM_EXIT_RADFRM	45

#define LEFT_DONE_LBL		6
#define RIGHT_DONE_LBL		47
#define TOP_DONE_LBL		45
#define BOTTOM_DONE_LBL		49

#define LEFT_DONE_CHKFRM	6
#define RIGHT_DONE_CHKFRM	47
#define TOP_DONE_CHKFRM		49
#define BOTTOM_DONE_CHKFRM	60

#define LEFT_EJECT_LBL		6
#define RIGHT_EJECT_LBL		47
#define TOP_EJECT_LBL		60
#define BOTTOM_EJECT_LBL	64

#define LEFT_EJECT_CHKFRM	6
#define RIGHT_EJECT_CHKFRM	47
#define TOP_EJECT_CHKFRM	64
#define BOTTOM_EJECT_CHKFRM	70

#define LEFT_CHG_LBL		53
#define RIGHT_CHG_LBL		94
#define TOP_CHG_LBL		1
#define BOTTOM_CHG_LBL		5

#define LEFT_CHG_CHKFRM		53
#define RIGHT_CHG_CHKFRM	94
#define TOP_CHG_CHKFRM		5
#define BOTTOM_CHG_CHKFRM	16

#define LEFT_CHROUTE_LBL	53
#define RIGHT_CHROUTE_LBL	94
#define TOP_CHROUTE_LBL		20
#define BOTTOM_CHROUTE_LBL	24

#define LEFT_CHROUTE_RADFRM	53
#define RIGHT_CHROUTE_RADFRM	94
#define TOP_CHROUTE_RADFRM	24
#define BOTTOM_CHROUTE_RADFRM	47

#define LEFT_VOLTP_LBL		53
#define RIGHT_VOLTP_LBL		94
#define TOP_VOLTP_LBL		51
#define BOTTOM_VOLTP_LBL	55

#define LEFT_VOLTP_RADFRM	53
#define RIGHT_VOLTP_RADFRM	94
#define TOP_VOLTP_RADFRM	55
#define BOTTOM_VOLTP_RADFRM	70

#define LEFT_BAL_LBL		20
#define RIGHT_BAL_LBL		80
#define TOP_BAL_LBL		71
#define BOTTOM_BAL_LBL		75

#define LEFT_BALL_LBL		5
#define RIGHT_BALL_LBL		20
#define TOP_BALL_LBL		75
#define BOTTOM_BALL_LBL		79

#define LEFT_BALR_LBL		80
#define RIGHT_BALR_LBL		95
#define TOP_BALR_LBL		75
#define BOTTOM_BALR_LBL		79

#define LEFT_BAL_SCALE		20
#define RIGHT_BAL_SCALE		80
#define TOP_BAL_SCALE		75
#define BOTTOM_BAL_SCALE	79

#define LEFT_BALCTR_BTN		35
#define RIGHT_BALCTR_BTN	65
#define TOP_BALCTR_BTN		80
#define BOTTOM_BALCTR_BTN	86

#define LEFT_OPTSEP		0
#define RIGHT_OPTSEP		100
#define TOP_OPTSEP		88

#define LEFT_RESET_BTN		4
#define RIGHT_RESET_BTN		32
#define TOP_RESET_BTN		91

#define LEFT_SAVE_BTN		36
#define RIGHT_SAVE_BTN		64
#define TOP_SAVE_BTN		91

#define LEFT_OPTOK_BTN		68
#define RIGHT_OPTOK_BTN		96
#define TOP_OPTOK_BTN		91

/* CD Information/Program window widgets */
#define LEFT_TOTTIMEIND		2
#define TOFF_TOTTIMEIND		4
#define BOFF_TOTTIMEIND		0

#define LEFT_INETOFFLN		2
#define TOFF_INETOFFLN		2

#define LEFT_LOGO		33
#define RIGHT_LOGO		49
#define TOFF_LOGO		6

#define LEFT_DLIST		81
#define RIGHT_DLIST		98
#define TOFF_DLIST		8

#define LEFT_ARTISTLBL		2
#define RIGHT_ARTISTLBL		79
#define TOFF_ARTISTLBL		0

#define LEFT_ARTIST		2
#define RIGHT_ARTIST		65

#define LEFT_TITLELBL		2
#define RIGHT_TITLELBL		79
#define TOFF_TITLELBL		2

#define LEFT_TITLE		2
#define RIGHT_TITLE		79

#define LOFF_FULLNAME		0
#define RIGHT_FULLNAME		79

#define LEFT_EXTDLBL		81
#define RIGHT_EXTDLBL		98
#define BOFF_EXTDLBL		0

#define LEFT_EXTD		81
#define RIGHT_EXTD		98
#define BOFF_EXTD		0

#define LEFT_DCRED		81
#define RIGHT_DCRED		98
#define BOFF_DCRED		0

#define LEFT_SEGMENTS		81
#define RIGHT_SEGMENTS		98
#define BOFF_SEGMENTS		0

#define LEFT_DBPROGSEP1		0
#define RIGHT_DBPROGSEP1	100
#define TOFF_DBPROGSEP1		8

#define LEFT_TRKLISTLBL		2
#define RIGHT_TRKLISTLBL	79
#define TOFF_TRKLISTLBL		6

#define LEFT_TRKLIST		2
#define RIGHT_TRKLIST		79
#define LOFF_TRKLIST		2
#define BOFF_TRKLIST		4

#define LEFT_RADIOLBL		81
#define RIGHT_RADIOLBL		98
#define TOFF_RADIOLBL		4

#define LEFT_RADIOBOX		82
#define RIGHT_RADIOBOX		97

#define LEFT_TTITLELBL		2
#define RIGHT_TTITLELBL		79
#define BOFF_TTITLELBL		0

#define LEFT_TTITLE		2
#define RIGHT_TTITLE		79
#define BOFF_TTITLE		2

#define LEFT_EXTTLBL		81
#define RIGHT_EXTTLBL		98
#define TOFF_EXTTLBL		4

#define LEFT_EXTT		81
#define RIGHT_EXTT		98
#define TOFF_EXTT		0

#define LEFT_TCRED		81
#define RIGHT_TCRED		98
#define TOFF_TCRED		0

#define LEFT_PGMLBL		81
#define RIGHT_PGMLBL		98
#define TOFF_PGMLBL		6

#define LEFT_ADDPGM		81
#define RIGHT_ADDPGM		98

#define LEFT_CLRPGM		81
#define RIGHT_CLRPGM		98

#define LEFT_SAVEPGM		81
#define RIGHT_SAVEPGM		98

#define LEFT_PGMSEQLBL		2
#define RIGHT_PGMSEQLBL		79
#define BOFF_PGMSEQLBL		8

#define LEFT_PGMSEQ		2
#define RIGHT_PGMSEQ		79

#define LEFT_USERREG		81
#define RIGHT_USERREG		98

#define LEFT_DBPROGSEP2		0
#define RIGHT_DBPROGSEP2	100
#define BOFF_DBPROGSEP2		16

#define LEFT_SUBMIT		6
#define RIGHT_SUBMIT		25
#define BOFF_SUBMIT		14

#define LEFT_FLUSH		29
#define RIGHT_FLUSH		48
#define BOFF_FLUSH		14

#define LEFT_RELOAD		52
#define RIGHT_RELOAD		71
#define BOFF_RELOAD		14

#define LEFT_DPOK		75
#define RIGHT_DPOK		94
#define BOFF_DPOK		14

/* Disc List window widgets */
#define LEFT_DLISTOPT		2
#define TOFF_DLISTOPT		8

#define LEFT_DLISTLBL		2
#define RIGHT_DLISTLBL		78
#define TOFF_DLISTLBL		6

#define LEFT_DLSHOWBTN		80
#define RIGHT_DLSHOWBTN		98
#define TOFF_DLSHOWBTN		10

#define LEFT_DLGOTOBTN		80
#define RIGHT_DLGOTOBTN		98
#define TOFF_DLGOTOBTN		2

#define LEFT_DLDELBTN		80
#define RIGHT_DLDELBTN		98
#define TOFF_DLDELBTN		2

#define LEFT_DLDELALLBTN	80
#define RIGHT_DLDELALLBTN	98
#define TOFF_DLDELALLBTN	2

#define LEFT_DLRESCANBTN	80
#define RIGHT_DLRESCANBTN	98
#define TOFF_DLRESCANBTN	2

#define LEFT_DLISTSEP		0
#define RIGHT_DLISTSEP		100
#define BOFF_DLISTSEP		10

#define LEFT_DLISTCANCEL	40
#define RIGHT_DLISTCANCEL	60
#define BOFF_DLISTCANCEL	10

#define LEFT_DISCLIST		2
#define RIGHT_DISCLIST		78
#define LOFF_DISCLIST		2
#define TOFF_DISCLIST		2
#define BOFF_DISCLIST		8

/* Full name editor window widgets */
#define LEFT_DAHEADLBL		2
#define RIGHT_DAHEADLBL		98
#define TOFF_DAHEADLBL		6

#define ROFF_DADISPNAMELBL	6

#define LEFT_DADISPNAMETXT	25
#define RIGHT_DADISPNAMETXT	80
#define TOFF_DADISPNAMETXT	10

#define LOFF_DAAUTOGENBTN	0
#define RIGHT_DAAUTOGENBTN	97

#define ROFF_DAFIRSTNAMELBL	6

#define LEFT_DAFIRSTNAMETXT	25
#define RIGHT_DAFIRSTNAMETXT	97
#define TOFF_DAFIRSTNAMETXT	6

#define ROFF_DALASTNAMELBL	6

#define LEFT_DALASTNAMETXT	25
#define RIGHT_DALASTNAMETXT	97
#define TOFF_DALASTNAMETXT	6

#define ROFF_DATHEBTN		6
#define TOFF_DATHEBTN		10

#define LEFT_DATHETXT		25
#define RIGHT_DATHETXT		46
#define TOFF_DATHETXT		6

#define LEFT_DASEP		0
#define RIGHT_DASEP		100
#define BOFF_DASEP		12

#define LEFT_DAOK		38
#define RIGHT_DAOK		62
#define BOFF_DAOK		12

#define LEFT_DASEP		0
#define RIGHT_DASEP		100
#define BOFF_DASEP		12

/* Disc details window widgets */
#define LEFT_DDDISCNUM		40
#define RIGHT_DDDISCNUM		60
#define TOFF_DDDISCNUM		4

#define LEFT_DDDISCLBL		4
#define RIGHT_DDDISCLBL		96
#define TOFF_DDDISCLBL		0

#define LEFT_DDSEP		0
#define RIGHT_DDSEP		100
#define TOFF_DDSEP		4

#define ROFF_DDSORTTITLE_LBL	4

#define LEFT_DDSORTTITLE_TXT	13
#define TOFF_DDSORTTITLE_TXT	6
#define ROFF_DDSORTTITLE_TXT	10

#define ROFF_DDTHELBL		6

#define LEFT_DDTHETXT		83
#define RIGHT_DDTHETXT		98
#define TOFF_DDTHETXT		6

#define ROFF_DDYEARLBL		4

#define LOFF_DDLABELLBL		10
#define ROFF_DDLABELLBL		6

#define LEFT_DDYEARTXT		13
#define RIGHT_DDYEARTXT		24
#define TOFF_DDYEARTXT		6

#define LOFF_DDLABELTXT		6
#define ROFF_DDLABELTXT		10
#define TOFF_DDLABELTXT		6

#define ROFF_DDCOMP		8

#define LEFT_DDGENRE0OPT	1
#define ROFF_DDGENRE0OPT	2
#define TOFF_DDGENRE0OPT	6

#define LEFT_DDSUBGENRE0OPT	41
#define LOFF_DDSUBGENRE0OPT	6
#define TOFF_DDSUBGENRE0OPT	6

#define LEFT_DDGENRE1OPT	1
#define ROFF_DDGENRE1OPT	2
#define TOFF_DDGENRE1OPT	2

#define LEFT_DDSUBGENRE1OPT	41
#define LOFF_DDSUBGENRE1OPT	6
#define TOFF_DDSUBGENRE1OPT	2

#define ROFF_DDDNUMLBL		4

#define LEFT_DDDNUMTXT		13
#define RIGHT_DDDNUMTXT		21
#define TOFF_DDDNUMTXT		6

#define LEFT_DDTNUMTXT		25
#define RIGHT_DDTNUMTXT		33
#define TOFF_DDTNUMTXT		6

#define LOFF_DDREGIONLBL	16

#define LOFF_DDREGIONTXT	0
#define TOFF_DDREGIONTXT	6

#define RIGHT_DDREGIONCHGBTN	98
#define LOFF_DDREGIONCHGBTN	0

#define LEFT_DDSEP2		0
#define RIGHT_DDSEP2		100
#define TOFF_DDSEP2		4

#define LEFT_DDNOTESLBL		2
#define RIGHT_DDNOTESLBL	98
#define TOFF_DDNOTESLBL		4

#define LEFT_DDOK		40
#define RIGHT_DDOK		60
#define BOFF_DDOK		12

#define LEFT_DDSEP3		0
#define RIGHT_DDSEP3		100
#define BOFF_DDSEP3		12

#define LEFT_DDCERTLBL		6
#define RIGHT_DDCERTLBL		34
#define BOFF_DDCERTLBL		4

#define LEFT_DDCERTIND		35
#define RIGHT_DDCERTIND		94
#define BOFF_DDCERTIND		4

#define LEFT_DDREVLBL		6
#define RIGHT_DDREVLBL		34
#define BOFF_DDREVLBL		0

#define LEFT_DDREVIND		35
#define RIGHT_DDREVIND		94
#define BOFF_DDREVIND		0

#define LEFT_DDDISCIDLBL	6
#define RIGHT_DDDISCIDLBL	34
#define BOFF_DDDISCIDLBL	0

#define LEFT_DDDISCIDIND	35
#define RIGHT_DDDISCIDIND	94
#define BOFF_DDDISCIDIND	0

#define LEFT_DDNOTESTXT		2
#define RIGHT_DDNOTESTXT	98
#define BOFF_DDNOTESTXT		6


/* Track details window widgets */
#define LEFT_DTAUTOTRKBTN	2
#define TOFF_DTAUTOTRKBTN	4

#define TOFF_DTPREV		6
#define ROFF_DTPREV		4

#define TOFF_DTNEXT		6
#define LOFF_DTNEXT		4

#define LEFT_DTTRKNUMLBL	45
#define RIGHT_DTTRKNUMLBL	55
#define TOFF_DTTRKNUMLBL	8

#define LEFT_TRKLBL		2
#define RIGHT_TRKLBL		98
#define TOFF_TRKLBL		4

#define LEFT_DTSEP		0
#define RIGHT_DTSEP		100
#define TOFF_DTSEP		4

#define ROFF_DTSORTTITLELBL	4

#define LEFT_DTSORTTITLETXT	13
#define TOFF_DTSORTTITLETXT	6
#define ROFF_DTSORTTITLETXT	10

#define ROFF_DTTHELBL		6

#define LEFT_DTTHETXT		83
#define RIGHT_DTTHETXT		98
#define TOFF_DTTHETXT		6

#define ROFF_DTARTISTLBL	4

#define LEFT_DTARTISTTXT	13
#define RIGHT_DTARTISTTXT	70
#define TOFF_DTARTISTTXT	6

#define ROFF_DTFULLNAMEBTN	6

#define ROFF_DTYEARLBL		4

#define LOFF_DTLABELLBL		10
#define ROFF_DTLABELLBL		6

#define ROFF_DTBPMLBL		4

#define LEFT_DTYEARTXT		13
#define RIGHT_DTYEARTXT		24
#define TOFF_DTYEARTXT		6

#define LOFF_DTLABELTXT		6
#define ROFF_DTLABELTXT		10
#define TOFF_DTLABELTXT		6

#define LEFT_DTBPMTXT		82
#define RIGHT_DTBPMTXT		98
#define TOFF_DTBPMTXT		6

#define LEFT_DTGENRE0OPT	1
#define ROFF_DTGENRE0OPT	2
#define TOFF_DTGENRE0OPT	6

#define LEFT_DTSUBGENRE0OPT	41
#define LOFF_DTSUBGENRE0OPT	6
#define TOFF_DTSUBGENRE0OPT	6

#define LEFT_DTGENRE1OPT	1
#define ROFF_DTGENRE1OPT	2
#define TOFF_DTGENRE1OPT	2

#define LEFT_DTSUBGENRE1OPT	41
#define LOFF_DTSUBGENRE1OPT	6
#define TOFF_DTSUBGENRE1OPT	2

#define LEFT_DTSEP2		0
#define RIGHT_DTSEP2		100
#define TOFF_DTSEP2		4

#define LEFT_DTNOTESLBL		2
#define RIGHT_DTNOTESLBL	98
#define TOFF_DTNOTESLBL		4

#define LEFT_DTOK		40
#define RIGHT_DTOK		60
#define BOFF_DTOK		12

#define LEFT_DTSEP3		0
#define RIGHT_DTSEP3		100
#define BOFF_DTSEP3		12

#define LEFT_DTISRCLBL		6
#define RIGHT_DTISRCLBL		19
#define BOFF_DTISRCLBL		4

#define LEFT_DTISRCIND		20
#define RIGHT_DTISRCIND		94
#define BOFF_DTISRCIND		4

#define LEFT_DTNOTESTXT		2
#define RIGHT_DTNOTESTXT	98
#define BOFF_DTNOTESTXT		4

/* Credits window widgets */
#define LEFT_CRAUTOTRKBTN	2
#define TOFF_CRAUTOTRKBTN	4

#define TOFF_CRPREV		6
#define ROFF_CRPREV		4

#define TOFF_CRNEXT		6
#define LOFF_CRNEXT		4

#define LEFT_CRDISCTRKLBL	45
#define RIGHT_CRDISCTRKLBL	55
#define TOFF_CRDISCTRKLBL	8

#define LEFT_CRTITLELBL		4
#define RIGHT_CRTITLELBL	96
#define TOFF_CRTITLELBL		4

#define LEFT_CRLISTLBL		4
#define RIGHT_CRLISTLBL		96
#define TOFF_CRLISTLBL		6

#define LEFT_CRLIST		2
#define RIGHT_CRLIST		98
#define TOFF_CRLIST		2
#define BOFF_CRLIST		6

#define LEFT_CRSEP1		0
#define RIGHT_CRSEP1		100
#define TOP_CRSEP1		39

#define LEFT_CREDITORLBL	4
#define RIGHT_CREDITORLBL	96
#define TOFF_CREDITORLBL	6

#define LEFT_CRPRIROLEOPT	3
#define ROFF_CRPRIROLEOPT	2
#define TOFF_CRPRIROLEOPT	6

#define LEFT_CRSUBROLEOPT	45
#define LOFF_CRSUBROLEOPT	6
#define TOFF_CRSUBROLEOPT	6

#define ROFF_CRNAMELBL		4

#define LEFT_CRNAMETXT		12
#define RIGHT_CRNAMETXT		70
#define TOFF_CRNAMETXT		6

#define LEFT_CRNOTESLBL		2
#define RIGHT_CRNOTESLBL	98
#define TOFF_CRNOTESLBL		10

#define LEFT_CRNOTESTXT		2
#define RIGHT_CRNOTESTXT	98
#define TOFF_CRNOTESTXT		0
#define BOFF_CRNOTESTXT		6

#define LEFT_CRSEP2		0
#define RIGHT_CRSEP2		100
#define BOFF_CRSEP2		12

#define LEFT_CRADD		6
#define RIGHT_CRADD		25
#define BOFF_CRADD		12

#define LEFT_CRMOD		29
#define RIGHT_CRMOD		48
#define BOFF_CRMOD		12

#define LEFT_CRDEL		52
#define RIGHT_CRDEL		71
#define BOFF_CRDEL		12

#define LEFT_CROK		75
#define RIGHT_CROK		94
#define BOFF_CROK		12

/* Segments window widgets */
#define LEFT_SGDISCNOLBL	40
#define RIGHT_SGDISCNOLBL	60
#define TOFF_SGDISCNOLBL	4

#define LEFT_SGDISCLBL		4
#define RIGHT_SGDISCLBL		96
#define TOFF_SGDISCLBL		0

#define LEFT_SGLISTLBL		4
#define RIGHT_SGLISTLBL		96
#define TOFF_SGLISTLBL		6

#define LEFT_SGLIST		2
#define RIGHT_SGLIST		98
#define TOFF_SGLIST		2
#define BOFF_SGLIST		6

#define LEFT_SGSEP1		0
#define RIGHT_SGSEP1		100
#define TOP_SGSEP1		33

#define LEFT_SGEDITORLBL	2
#define RIGHT_SGEDITORLBL	75
#define TOFF_SGEDITORLBL	6

#define ROFF_SGNAMELBL		4

#define LEFT_SGNAMETXT		15
#define RIGHT_SGNAMETXT		72
#define TOFF_SGNAMETXT		6

#define LEFT_SGTRACKLBL		15
#define RIGHT_SGTRACKLBL	24
#define TOFF_SGTRACKLBL		6

#define LEFT_SGFRAMELBL		26
#define RIGHT_SGFRAMELBL	43
#define TOFF_SGFRAMELBL		6

#define ROFF_SGSTARTLBL		4

#define LEFT_SGSTARTTRKTXT	15
#define RIGHT_SGSTARTTRKTXT	24
#define TOFF_SGSTARTTRKTXT	2

#define LEFT_SGSTARTFRMTXT	26
#define RIGHT_SGSTARTFRMTXT	43
#define TOFF_SGSTARTFRMTXT	2

#define ROFF_SGENDLBL		4

#define LEFT_SGENDTRKTXT	15
#define RIGHT_SGENDTRKTXT	24
#define TOFF_SGENDTRKTXT	2

#define LEFT_SGENDFRMTXT	26
#define RIGHT_SGENDFRMTXT	43
#define TOFF_SGENDFRMTXT	2

#define LEFT_SGSTARTPTRLBL	43
#define RIGHT_SGSTARTPTRLBL	51

#define LEFT_SGENDPTRLBL	43
#define RIGHT_SGENDPTRLBL	51

#define LEFT_SGSETBTN		51
#define RIGHT_SGSETBTN		60

#define LEFT_SGPLAYSETLBL	49
#define RIGHT_SGPLAYSETLBL	62
#define BOFF_SGPLAYSETLBL	2

#define LEFT_SGPLAYPAUSBTN	78
#define RIGHT_SGPLAYPAUSBTN	98
#define TOFF_SGPLAYPAUSBTN	6

#define LEFT_SGSTOPBTN		78
#define RIGHT_SGSTOPBTN		98
#define TOFF_SGSTOPBTN		0

#define LEFT_SGNOTESLBL		2
#define RIGHT_SGNOTESLBL	75
#define TOFF_SGNOTESLBL		10

#define LEFT_SGNOTESTXT		2
#define RIGHT_SGNOTESTXT	75
#define TOFF_SGNOTESTXT		0
#define BOFF_SGNOTESTXT		6

#define LEFT_SGSEGMENTLBL	78
#define RIGHT_SGSEGMENTLBL	98
#define BOFF_SGSEGMENTLBL	0

#define LEFT_SGCREDITSBTN	78
#define RIGHT_SGCREDITSBTN	98
#define BOFF_SGCREDITSBTN	6

#define LEFT_SGSEP2		0
#define RIGHT_SGSEP2		100
#define BOFF_SGSEP2		12

#define LEFT_SGADD		6
#define RIGHT_SGADD		25
#define BOFF_SGADD		12

#define LEFT_SGMOD		29
#define RIGHT_SGMOD		48
#define BOFF_SGMOD		12

#define LEFT_SGDEL		52
#define RIGHT_SGDEL		71
#define BOFF_SGDEL		12

#define LEFT_SGOK		75
#define RIGHT_SGOK		94
#define BOFF_SGOK		12

/* SubmitURL window widgets */
#define LOFF_SULOGO		10
#define ROFF_SULOGO		10
#define TOFF_SULOGO		6

#define LEFT_SUHEADINGLBL	15
#define RIGHT_SUHEADINGLBL	95
#define TOFF_SUHEADINGLBL	6

#define LEFT_SUCATEGTXT		18
#define RIGHT_SUCATEGTXT	97
#define TOFF_SUCATEGTXT		8

#define ROFF_SUCATEGLBL		4

#define LEFT_SUNAMETXT		18
#define RIGHT_SUNAMETXT		97
#define TOFF_SUNAMETXT		6

#define ROFF_SUNAMELBL		4

#define LEFT_SUURLTXT		18
#define RIGHT_SUURLTXT		97
#define TOFF_SUURLTXT		6

#define ROFF_SUURLLBL		4

#define LEFT_SUDESCLBL		3
#define RIGHT_SUDESCLBL		97
#define TOFF_SUDESCLBL		6

#define LEFT_SUDESCTXT		3
#define RIGHT_SUDESCTXT		97
#define TOFF_SUDESCTXT		0
#define BOFF_SUDESCTXT		6

#define LEFT_SUSUBMITBTN	20
#define RIGHT_SUSUBMITBTN	40
#define BOFF_SUSUBMITBTN	12

#define LEFT_SUOKBTN		60
#define RIGHT_SUOKBTN		80
#define BOFF_SUOKBTN		12

#define LEFT_SUSEP		0
#define RIGHT_SUSEP		100
#define BOFF_SUSEP		12

/* Region selector popup widgets */
#define LEFT_REGIONSELLBL	4
#define RIGHT_REGIONSELLBL	96
#define TOFF_REGIONSELLBL	6

#define LEFT_REGIONLIST		4
#define RIGHT_REGIONLIST	96
#define TOFF_REGIONLIST		6
#define BOFF_REGIONLIST		6

#define LEFT_REGIONSEP		0
#define RIGHT_REGIONSEP		100
#define BOFF_REGIONSEP		12

#define LEFT_REGIONOK		35
#define RIGHT_REGIONOK		65
#define BOFF_REGIONOK		12

/* Match selector popup widgets */
#define LOFF_MATCHSELLOGO	10
#define ROFF_MATCHSELLOGO	10
#define TOFF_MATCHSELLOGO	6

#define LEFT_MATCHSELLBL	15
#define RIGHT_MATCHSELLBL	95
#define TOFF_MATCHSELLBL	6

#define LEFT_MATCHLIST		3
#define RIGHT_MATCHLIST		97
#define TOFF_MATCHLIST		6
#define BOFF_MATCHLIST		6

#define LEFT_MATCHSEP		0
#define RIGHT_MATCHSEP		100
#define BOFF_MATCHSEP		12

#define LEFT_MATCHOK		40
#define RIGHT_MATCHOK		60
#define BOFF_MATCHOK		12

/* userreg widgets */
#define LOFF_URLOGO		10
#define ROFF_URLOGO		10
#define TOFF_URLOGO		8

#define LEFT_URCAPTIONLBL	10
#define RIGHT_URCAPTIONLBL	95
#define TOFF_URCAPTIONLBL	8

#define LOFF_URHANDLELBL	6
#define ROFF_URHANDLELBL	6

#define LEFT_URHANDLETXT	35
#define RIGHT_URHANDLETXT	95
#define TOFF_URHANDLETXT	8

#define LOFF_URPASSWDLBL	6
#define ROFF_URPASSWDLBL	6

#define LEFT_URPASSWDTXT	35
#define RIGHT_URPASSWDTXT	95
#define TOFF_URPASSWDTXT	6

#define LOFF_URVPASSWDLBL	6
#define ROFF_URVPASSWDLBL	6

#define LEFT_URVPASSWDTXT	35
#define RIGHT_URVPASSWDTXT	95
#define TOFF_URVPASSWDTXT	6

#define LOFF_URHINTLBL		6
#define ROFF_URHINTLBL		6

#define LEFT_URHINTTXT		35
#define RIGHT_URHINTTXT		75
#define TOFF_URHINTTXT		6

#define LOFF_URGETHINTBTN	0

#define LOFF_UREMAILLBL		6
#define ROFF_UREMAILLBL		6

#define LEFT_UREMAILTXT		35
#define RIGHT_UREMAILTXT	95
#define TOFF_UREMAILTXT		6

#define LOFF_URREGIONLBL	6
#define ROFF_URREGIONLBL	6

#define LEFT_URREGIONTXT	35
#define RIGHT_URREGIONTXT	75
#define TOFF_URREGIONTXT	6

#define LOFF_URREGIONCHGBTN	0

#define LOFF_URPOSTALLBL	6
#define ROFF_URPOSTALLBL	6

#define LEFT_URPOSTALTXT	35
#define RIGHT_URPOSTALTXT	95
#define TOFF_URPOSTALTXT	6

#define LOFF_URAGELBL		6
#define ROFF_URAGELBL		6

#define LEFT_URAGETXT		35
#define RIGHT_URAGETXT		48
#define TOFF_URAGETXT		6

#define LOFF_URGENDERLBL	10
#define ROFF_URGENDERLBL	6

#define LEFT_URGENDERFRM	63
#define TOFF_URGENDERFRM	6

#define LEFT_URALLOWMAILBTN	10
#define TOFF_URALLOWMAILBTN	6

#define LEFT_URALLOWSTATSBTN	10
#define TOFF_URALLOWSTATSBTN	6

#define LEFT_URSEP		0
#define RIGHT_URSEP		100
#define BOFF_URSEP		12

#define LEFT_UROKBTN		10
#define RIGHT_UROKBTN		34
#define BOFF_UROKBTN		12

#define LEFT_URPRIVBTN		38
#define RIGHT_URPRIVBTN		62
#define BOFF_URPRIVBTN		12

#define LEFT_URCANCELBTN	66
#define RIGHT_URCANCELBTN	90
#define BOFF_URCANCELBTN	12

/* Help popup widgets */
#define LEFT_TOPIC		2
#define TOFF_TOPIC		6

#define LEFT_HELPTXT		2
#define RIGHT_HELPTXT		98
#define TOFF_HELPTXT		10
#define BOFF_HELPTXT		6

#define LEFT_HELPSEP		0
#define RIGHT_HELPSEP		100
#define BOFF_HELPSEP		12

#define LEFT_ABOUT		15
#define RIGHT_ABOUT		40
#define BOFF_ABOUT		12

#define LEFT_HELPCANCEL		60
#define RIGHT_HELPCANCEL	85
#define BOFF_HELPCANCEL		12

/* Authorization popup widgets */
#define LEFT_AUTHLBL		5
#define RIGHT_AUTHLBL		95
#define TOFF_AUTHLBL		10

#define LOFF_AUTHNAMELBL	6
#define ROFF_AUTHNAMELBL	6

#define LEFT_AUTHNAMETXT	23
#define RIGHT_AUTHNAMETXT	95
#define TOFF_AUTHNAMETXT	10

#define LOFF_AUTHPASSLBL	6
#define ROFF_AUTHPASSLBL	6

#define LEFT_AUTHPASSTXT	23
#define RIGHT_AUTHPASSTXT	95
#define TOFF_AUTHPASSTXT	6

#define LEFT_AUTHSEP		0
#define RIGHT_AUTHSEP		100
#define BOFF_AUTHSEP		12

#define LEFT_AUTHOK		18
#define RIGHT_AUTHOK		42
#define BOFF_AUTHOK		12

#define LEFT_AUTHCANCEL		58
#define RIGHT_AUTHCANCEL	82
#define BOFF_AUTHCANCEL		12


/* Public function prototypes */
extern void	geom_force(widgets_t *);
extern void	geom_main_chgmode(widgets_t *);
extern int	geom_main_getmode(void);

#endif	/* __GEOM_H__ */

